/*******************************************************************************
  主ｿｰｽ ﾌｧｲﾙ
  会社:
	Microchip Technology Inc.
  ﾌｧｲﾙ名:
	main.c
  概要:
	このﾌｧｲﾙはﾌﾟﾛｼﾞｪｸﾄの"main"関数を含みます。
  説明:
	このﾌｧｲﾙはﾌﾟﾛｼﾞｪｸﾄの"main"関数を含みます。
  版 1.0
*******************************************************************************/
/*******************************************************************************
* 不許複製 (C) 2022 Microchip Technology Inc.とその子会社
*
* これらの条件の遵守を条件として、Microchipｿﾌﾄｳｪｱと何れの派生物をMicrochip製品に
* 限って使用することができます。Microchipｿﾌﾄｳｪｱを伴うかもしれない(開放ｿｰｽ ｿﾌﾄｳｪｱ
* を含む)第三者ｿﾌﾄｳｪｱの使用に適用される第三者の許諾条件を遵守するのはあなたの責
* 任です。
*
* このｿﾌﾄｳｪｱはMicrochipの"現状そのまま"によって供給されます。非侵害、商品性、特
* 定目的への適合性のどの暗黙の保証を含め、明示的、暗示的または法令であろうがこの
* ｿﾌﾄｳｪｱには適用されません。
*
* 例えMicrochipが可能性を進言されたり、損害が予見できるとしても、原因の如何に関
* わらず、如何なる場合でもMicrochipはｿﾌﾄｳｪｱに関連する如何なる種類の間接的、特別、
* 懲罰的、偶発的または必然的な損失、損害、費用または支払いの責任を負いません。
* 法によって許される最大限の範囲まで、このｿﾌﾄｳｪｱに関連するどの方法での全請求に
* 於いても、Microchipの総責任額は、もしあれば、あなたがこのｿﾌﾄｳｪｱに対して
* Microchipへ直接支払った費用の額を超えません。
*******************************************************************************/

#include <xc.h>
#include <avr/sfr_defs.h>
#include <avr/interrupt.h>

// INTAﾋﾟﾝ
#define INTA PORTA3
#define INTA_PORT PORTA
#define INTA_DDR DDRA

// SPIﾋﾟﾝ
#define SPI_PORT PORTB
#define DD_SS PORTB0
#define DD_SCK PORTB1
#define DD_MOSI PORTB2
#define DD_MISO PORTB3
#define SPI_DDR DDRB

#define IOCON_ODR		2	// ODRはIOCONﾚｼﾞｽﾀのﾋﾞｯﾄ2で、INTA出力の開放ﾄﾞﾚｲﾝ構成を制御します。
#define IOCON_INTPOL	1	// INTPOLはIOOCNのﾋﾞｯﾄ1で、INTA出力極性を制御し、既定はLow有効です。

/* MCP23S17の機能的なﾚｼﾞｽﾀの写し */
unsigned char reg_iodira=0xFF;	// DDRxﾋﾞｯﾄのﾘｾｯﾄ状態と同じ入力が既定なので行うことはありません。
unsigned char reg_iodirb=0xFF;	// DDRxﾋﾞｯﾄのﾘｾｯﾄ状態と同じ入力が既定なので行うことはありません。
unsigned char reg_ipola;
unsigned char reg_ipolb;
unsigned char reg_gpintena;
unsigned char reg_gpintenb;
unsigned char reg_defvala;
unsigned char reg_defvalb;
unsigned char reg_intcona;
unsigned char reg_intconb;
unsigned char reg_iocon=0x38;	// 現在の模倣の既定設定
unsigned char reg_gppua;
unsigned char reg_gppub;
unsigned char reg_intfa;
unsigned char reg_intfb;
unsigned char reg_intcapa;
unsigned char reg_intcapb;
unsigned char reg_olata;
unsigned char reg_olatb;

/* 模倣応用条件変数 */
unsigned char reg_inta;

/* 原型宣言 */
void clear_inta(void);
void ISR_set_inta(void);
void ISR_latch_gpioa(void);
void configure_interrupts(void);
void init_ports(void);
void init_spi(void);

unsigned char get_spi_byte(void);

/* 割り込み */
ISR(INT0_vect) 
{
  reg_intfa|=0x01;		// 割り込み事象登録
  ISR_latch_gpioa();	// GPIOAﾎﾟｰﾄ状態記録
  ISR_set_inta();		// INTA割り込み合図
}

ISR(INT1_vect)
{
  reg_intfa|=0x02;		// 割り込み事象登録
  ISR_latch_gpioa();	// GPIOAﾎﾟｰﾄ状態記録
  ISR_set_inta();		// INTA割り込み合図
}

ISR(INT2_vect)
{
  reg_intfa|=0x04;		// 割り込み事象登録
  ISR_latch_gpioa();	// GPIOAﾎﾟｰﾄ状態記録
  ISR_set_inta();		// INTA割り込み合図
}

ISR(INT3_vect)
{
  reg_intfa|=0x08;		// 割り込み事象登録
  ISR_latch_gpioa();	// GPIOAﾎﾟｰﾄ状態記録
  ISR_set_inta();		// INTA割り込み合図
}

ISR(INT4_vect)
{
  reg_intfa|=0x10;		// 割り込み事象登録
  ISR_latch_gpioa();	// GPIOAﾎﾟｰﾄ状態記録
  ISR_set_inta();		// INTA割り込み合図
}
ISR(INT5_vect)
{
  reg_intfa|=0x20;		// 割り込み事象登録
  ISR_latch_gpioa();	// GPIOAﾎﾟｰﾄ状態記録
  ISR_set_inta();		// INTA割り込み合図
}

ISR(INT6_vect)
{
  reg_intfa|=0x40;		// 割り込み事象登録
  ISR_latch_gpioa();	// GPIOAﾎﾟｰﾄ状態記録
  ISR_set_inta();		// INTA割り込み合図
}

ISR(INT7_vect)
{
  reg_intfa|=0x80;		// 割り込み事象登録
  ISR_latch_gpioa();	// GPIOAﾎﾟｰﾄ状態記録
  ISR_set_inta();		// INTA割り込み合図
}

int main(void)
{
  unsigned char spi_command,reg_address,reg_data, expander_address;

  init_ports();		// 必須ﾊｰﾄﾞｳｪｱ設定(初期化)
  init_spi();		// SPIﾊｰﾄﾞｳｪｱ設定(初期化)

  expander_address=(0x40+((PINA&0x07)<<1));		// A2～0ﾋﾟﾝから拡張器ｱﾄﾞﾚｽ取得($40～$4Eが可能)

  while(1)	// 主動作繰り返し
  {
	while(((spi_command=get_spi_byte())&0xFE)!=expander_address);	// 有効なSPI制御ﾊﾞｲﾄ待ち
	reg_address=get_spi_byte();										// 有効な場合での後続するSPI拡張器ﾚｼﾞｽﾀ ｱﾄﾞﾚｽ取得

	if(spi_command==expander_address)	// 有効な書き込み命令('0100xxx0')で、
	// 書き込み操作処理
	{
	  reg_data=get_spi_byte();			// 書き込み操作用SPI拡張器ﾚｼﾞｽﾀ ﾃﾞｰﾀ取得

	  switch(reg_address)
	  {
		// IODIRAは外部割り込みが必要なため、ﾎﾟｰﾄDの下位ﾆﾌﾞﾙとﾎﾟｰﾄEの上位ﾆﾌﾞﾙで模倣されます。
		case 0x00:
		reg_iodira=reg_data;			// IODIRA指定値保存

		DDRD&=(0xF0 | ~reg_data);		// ﾎﾟｰﾄD下位ﾆﾌﾞﾙ解除
		DDRE&=(0x0F | ~reg_data);		// ﾎﾟｰﾄE上位ﾆﾌﾞﾙ解除
		DDRD|=(0x0F & ~reg_data);		// ﾎﾟｰﾄD下位ﾆﾌﾞﾙ入力/出力設定
		DDRE|=(0xF0 & ~reg_data);		// ﾎﾟｰﾄE上位ﾆﾌﾞﾙ入力/出力設定

		// IODIRA変更が割り込み機能に影響を及ぼすため設定再評価
		configure_interrupts();
		break;

		// IODIRBは単に論理反転してDDRCで模倣され、GPPUBﾚｼﾞｽﾀ設定と共に更新
		case 0x01:
		reg_iodirb=reg_data;			// IODIRB指定値保存

		DDRC=(~reg_data);				// 反転論理値でDDRC更新
		PORTC|=(reg_iodirb&reg_gppub);	// 入力として構成設定されたﾎﾟｰﾄ ﾋﾞｯﾄとGPPUB設定で'1'書き込み
		// INTB機能を模倣しないため、ここでの割り込み構成設定再評価は不要
		break;

		// IPOLAは読み込み操作でGPIOAとXORされる論理遮蔽値です。
		case 0x02:
		reg_ipola=reg_data;				// IPOLA指定値保存
		break;

		// IPOLBは読み込み操作でGPIOBとXORされる論理遮蔽値です。
		case 0x03:
		reg_ipolb=reg_data;				// IPOLB指定値保存
		break;

		// GPINTENAはINTA割り込み機能の全般的な許可
		case 0x04:
		reg_gpintena=reg_data;			// GPINTENA指定値保存

		// 割り込みﾋﾟﾝで有効なINTENAﾋﾞｯﾄがあればそれを処理
		if(reg_gpintena & reg_iodira)
		{

		  // GPINTENA,INTCON,DEFVALのﾚｼﾞｽﾀのどれかの変更で必要とし得るため、割り込み構成設定機能を呼び出し
		  configure_interrupts();

		  sei();						// 外部割り込みが有効とされたため全体割り込み許可
		}
		else
		{
		  EIMSK=0x00;					// さもなければ外部割り込み禁止
		  cli();						// *** 注意 *** (変更/追加などによって)別の場所で割り込みを使う場合、これを削除する必要があるかもしれません。
		}
		break;

		// GPINTENBはINTB割り込み機能の全般的な許可 [模倣なし!!]
		case 0x05:
		reg_gpintenb=reg_data;			// GPINTENB指定値保存
		break;

		// DEFVALAは選ばれたならGPIOAﾋﾟﾝの割り込み起動ﾚﾍﾞﾙを定義します。
		case 0x06:
		reg_defvala=reg_data;			// DEFVALA指定値保存。割り込み条件変更の可能性のためそれらを再評価
		// GPINTENA,INTCON,DEFVALのﾚｼﾞｽﾀのどれかの変更で必要とし得るため、割り込み構成設定機能を呼び出し
		configure_interrupts();
		break;

		// DEFVALBは選ばれたならGPIOBﾋﾟﾝの割り込み起動ﾚﾍﾞﾙを定義します。 [模倣なし!!]
		case 0x07:
		reg_defvalb=reg_data;			// DEFVALB指定値保存
		break;

		// INTCONA
		case 0x08:
		reg_intcona=reg_data;			// INTCONA指定値保存
		configure_interrupts();			// 更新に続く割り込み構成設定を更新
		break;

		// INTCONB
		case 0x09:
		reg_intconb=reg_data;			// INTCONB指定値保存、模倣なし、することなし
		break;

		// IOCON反映ﾚｼﾞｽﾀ、現在はODRとINTPOLの部分的な模倣のみ
		case 0x0A:
		case 0x0B:
		reg_iocon=reg_data;				// 先に重要な全てのODRとINTPOLのﾋﾞｯﾄで指定値を保存
		reg_iocon|=0x38;				// 現在SEQOP,DISSLW,HAENを'1'として封鎖
		reg_iocon&=0x3E;				// 現在BANK,MIRRORを'0'として封鎖
		clear_inta();					// IOCONの変更はINTA構成設定を変え得るため最初に保留中の割り込みをもとに戻します。
		break;

		// GPPUAはGPIOA入力のﾌﾟﾙｱｯﾌﾟを構成設定します。
		case 0x0C:
		reg_gppua=reg_data;						// GPPUA指定値保存
		PORTD|=((reg_iodira&reg_gppua)&0x0F);	// 入力して構成設定されGPPUAが設定されたﾎﾟｰﾄD下位ﾆﾌﾞﾙに'1'書き込み
		PORTE|=((reg_iodira&reg_gppua)&0xF0);	// 入力して構成設定されGPPUAが設定されたﾎﾟｰﾄE上位ﾆﾌﾞﾙに'1'書き込み
		break;

		// GPPUBGPIOB入力のﾌﾟﾙｱｯﾌﾟを構成設定します。
		case 0x0D:
		reg_gppub=reg_data;						// GPPUB指定値保存
		PORTC|=(reg_iodirb&reg_gppub);			// 入力して構成設定されGPPUBが設定されたﾎﾟｰﾄCに'1'書き込み
		break;

		// INTFAは読み込み専用、することなし
		case 0x0E:
		break;

		// INTFBは読み込み専用、することなし
		case 0x0F:
		break;

		// INTCAPAは読み込み専用、することなし
		case 0x10:
		break;

		// INTCAPBは読み込み専用、することなし
		case 0x11:                  
		break;

		// GPIOAやOLATAのﾚｼﾞｽﾀ書き込みは同じことで、出力として設定されたﾎﾟｰﾄを駆動します。
		case 0x12:
		case 0x14:
		reg_olata=reg_data;				// OLATA指定値保存


		PORTD&=(0xF0|(reg_data&(~reg_iodira)));		// PORTD下位ﾆﾌﾞﾙ解除
		PORTE&=(0x0F|(reg_data&(~reg_iodira)));		// PORTE上位ﾆﾌﾞﾙ解除
		PORTD|=(0x0F&(reg_data&(~reg_iodira)));		// PORTD下位ﾆﾌﾞﾙ設定
		PORTE|=(0xF0&(reg_data&(~reg_iodira)));		// PORTE上位ﾆﾌﾞﾙ設定
		break;

		// OLATBﾚｼﾞｽﾀは出力として設定されたﾎﾟｰﾄ ﾋﾟﾝを駆動します。GPIOB($13)への書き込みはOLATB($15)へと同じです。
		case 0x13:
		case 0x15:
		reg_olatb=reg_data;				// OLATB指定値保存

		PORTC=(reg_data&(~reg_iodirb));	// 出力設定のPORTCﾋﾟﾝだけ'1'を書かれるべきで、さもなければ入力でﾌﾟﾙｱｯﾌﾟが有効にされます。
		break;

		default: break;
	  }
	}

	// 読み込み操作処理
	if(spi_command==(expander_address|0x01))		// 有効な書き込み命令('0100xxx1')で、
	{
	  switch(reg_address)
	  {
		// IODIRAは外部割り込みが必要なため、ﾎﾟｰﾄDの下位ﾆﾌﾞﾙとﾎﾟｰﾄEの上位ﾆﾌﾞﾙで模倣されます。
		case 0x00:
		reg_data=reg_iodira;			// 保存された複製からSPI用応答値を準備
		break;

		// IODIRBはDDRCによって模倣されます。
		case 0x01:
		reg_data=reg_iodirb;			// 保存された複製からSPI用応答値を準備
		break;

		// IPOLAは単にﾚｼﾞｽﾀ保存値を読みます。
		case 0x02:
		reg_data=reg_ipola;				// 保存された複製からSPI用応答値を準備
		break;

		// IPOLBは単にﾚｼﾞｽﾀ保存値を読みます。
		case 0x03:
		reg_data=reg_ipolb;				// 保存された複製からSPI用応答値を準備
		break;

		// GPINTENAは単にﾚｼﾞｽﾀ保存値を読みます。
		case 0x04:
		reg_data=reg_gpintena;			// 保存された複製からSPI用応答値を準備
		break;

		// GPINTENBは単にﾚｼﾞｽﾀ保存値を読みます。
		case 0x05:
		reg_data=reg_gpintenb;			// 保存された複製からSPI用応答値を準備
		break;

		// DEFVALAは単にﾚｼﾞｽﾀ保存値を読みます。
		case 0x06:
		reg_data=reg_defvala;			// 保存された複製からSPI用応答値を準備
		break;

		// DEFVALBは単にﾚｼﾞｽﾀ保存値を読みます。
		case 0x07:
		reg_data=reg_defvalb;			// 保存された複製からSPI用応答値を準備
		break;

		// INTCONAは単にﾚｼﾞｽﾀ保存値を読みます。
		case 0x08:
		reg_data=reg_intcona;			// 保存された複製からSPI用応答値を準備
		break;

		// INTCONBは単にﾚｼﾞｽﾀ保存値を読みます。
		case 0x09:
		reg_data=reg_intconb;			// 保存された複製からSPI用応答値を準備
		break;

		// IOCONは単にﾚｼﾞｽﾀ保存値を読みます。
		case 0x0A:
		case 0x0B:
		reg_data=reg_iocon;				// 保存された複製からSPI用応答値を準備
		break;

		// GPPUAは単にﾚｼﾞｽﾀ保存値を読みます。
		case 0x0C:
		reg_data=reg_gppua;				// 保存された複製からSPI用応答値を準備
		break;

		// GPPUBは単にﾚｼﾞｽﾀ保存値を読みます。
		case 0x0D:
		reg_data=reg_gppub;				// 保存された複製からSPI用応答値を準備
		break;

		// INTFAは単にﾚｼﾞｽﾀ保存値を読み、割り込み要求ﾌﾗｸﾞはGPIOAﾚｼﾞｽﾀ読み込みで解除されます。
		case 0x0E:
		reg_data=reg_intfa;				// 保存された複製からSPI用応答値を準備
		reg_intfa=0;					// ﾃﾞｰﾀｼｰﾄではここを詳述していませんが、論理性からこのﾚｼﾞｽﾀは読み込み/解除と推測します。
		break;

		// INTFBは単にﾚｼﾞｽﾀ保存値を読みます(ATmegaS128ﾊｰﾄﾞｳｪｱでは未実装、INTFAだけが支援されます。)
		case 0x0F:
		reg_data=reg_intfb;				// 保存された複製からSPI用応答値を準備
		break;

		// INTCAPAは単にﾚｼﾞｽﾀ保存値を読みますが有効ならばINTAをﾘｾｯﾄします。
		case 0x10:
		reg_data=reg_intcapa;			// 保存された複製からSPI用応答値を準備
		reg_intcapa=0;					// Reading INTCAPA clears it
		clear_inta();
		break;

		// INTCAPBは単にﾚｼﾞｽﾀ保存値を読みます(ATmegaS128ﾊｰﾄﾞｳｪｱでは未実装、INTCAPAだけが支援されます。)
		case 0x11:
		reg_data=reg_intcapb;			// 保存された複製からSPI用応答値を準備
		break;

		// IPOLA反転の可能性を考慮してPIND下位ﾆﾌﾞﾙとPINE上位ﾆﾌﾞﾙから合成したGPIOA読み取り
		// GPIOA読み込みが存在するならINTA信号を解除することに注意してください。
		case 0x12:
		reg_data=(((PIND&0x0F)|(PINE&0xF0))^reg_ipola);		// 保存された複製からSPI用応答値を準備
		reg_intcapa=0;										// GPIOA読み込みはINTCAPAを解除
		if(reg_inta)										// INTA割り込みが有効(活性)なら、それを解除
		{
		  clear_inta();
		}
		break;

		// GPIOB読み取り、PINCはIPOLB反転の可能性を考慮します。
		case 0x13:
		reg_data=(PINC^reg_ipolb);		// 保存された複製からSPI用応答値を準備
		break;

		// OLATAﾚｼﾞｽﾀ読み取りは単に(ﾗｯﾁ)ﾚｼﾞｽﾀを読みます。
		case 0x14:
		reg_data=reg_olata;				// SPI応答用OLATA状態取得/準備
		break;

		// OLATBﾚｼﾞｽﾀ読み取りは単に(ﾗｯﾁ)ﾚｼﾞｽﾀを読みます。
		case 0x15:
		reg_data=reg_olatb;				// SPI応答用OLATB状態取得/準備
		break;

		default:
		reg_data=0;						// 無効な読み込み要求の場合、定義された状態を応答へ与えるだけです。
		break;
	  }

	  if(!(SPSR&(1<<SPIF))) SPDR=reg_data;		// SPIが未だ準備が整っているなら、応答を準備
	  get_spi_byte();							// 主装置の従装置応答請求待ち
	}
  } // 主装置繰り返しの終わり
 } // main()の終わり

/* 作業関数 */

// clear_inta : 有効(活性)の場合にINTA信号解除の活動の必要性を決めるのに使用
void clear_inta()
{
  if(reg_iocon&(1<<IOCON_ODR))			// INTAが開放ﾄﾞﾚｲﾝとして構成設定されたなら、
  {
	INTA_DDR&=~(1<<INTA);				// INTAﾋﾟﾝを入力として設定
	INTA_PORT|=(1<<INTA);				// ﾌﾟﾙｱｯﾌﾟ有効
  }
  else
  {
	if(reg_iocon&(1<<IOCON_INTPOL))		// INTAが標準出力なら、
	{
	  INTA_PORT&=~(1<<INTA);			// 解除するのにHigh活性動作ならINTAをLowに駆動
	}
	else
	{
	  INTA_PORT|=(1<<INTA);				// 解除するのにLow活性動作ならINTAをHighに駆動
	}
  }
  reg_inta=0;							// INTA有効(活性)ﾌﾗｸﾞを解除
}

// ISR_latch_gpioa : 外部割り込みの間にINTCAPA模倣でPIND下位ﾆﾌﾞﾙとPINE上位ﾆﾌﾞﾙでのGPIOAﾎﾟｰﾄの状態をﾗｯﾁするのに使用
// 注意 ***************** 割り込み処理の外側で呼ばれるべきではありません。 *****************
void ISR_latch_gpioa()
{
  reg_intcapa=(PIND&0x0F);				// 下位ﾆﾌﾞﾙ形成
  reg_intcapa|=(PINE&0xF0);				// 上位ﾋﾞﾌﾞﾙ合成
}

// ISR_set_inta : 外部割り込みの間にINTA信号を有効にする活動の必要性を決めるのに使用
// 注意 ***************** 割り込み処理の外側で呼ばれるべきではありません。 *****************
void ISR_set_inta()
{
  if(reg_iocon&(1<<IOCON_ODR))			// INTAが開放ﾄﾞﾚｲﾝとして構成設定されたなら、
  {
	INTA_PORT&=~(1<<INTA);				// ﾌﾟﾙｱｯﾌﾟを禁止してﾋﾟﾝをLow状態に設定
	INTA_DDR|=(1<<INTA);				// INTAﾋﾟﾝをLowに駆動するために出力を有効化
  }
  else
  {
	if(reg_iocon&(1<<IOCON_INTPOL))		// INTA標準出力、INTPOLに応じてLowまたはHighを設定
	{
	  INTA_PORT|=(1<<INTA);				// 設定するのにHigh活性動作ならINTAをHighに駆動
	}
	else
	{
	  INTA_PORT&=~(1<<INTA);			// 設定するのにLow活性動作ならINTAをLowに駆動
	}
  }
  reg_inta=1;							// 割り込み信号有効(活性)を記録
}

// configure_interrupts : ATmegaS128外部割り込み機構をMCP23S17ﾊｰﾄﾞｳｪｱを模倣するように構成設定するのに使用
// この関数は割り込み活性の場合の競合状態を避けるため割り込み禁止でだけ呼びます。
// 注意: 保留中の割り込みも解除されます。!!!!
// 8つの外部割り込みだけを持つため、IOCON.MIRRORの機能は余分で模倣されません。
void configure_interrupts()
{
  unsigned char int_bits, sreg;
  sreg=SREG;							// 全体割り込み状態を保存
  cli();								// 割り込みﾊｰﾄﾞｳｪｱを弄り回す間の変な状況を防ぐために全体割り込みを禁止

  // IODIRAﾚｼﾞｽﾀ変更でもこれを呼ぶのを忘れないことに注意 !!!
  int_bits=(reg_gpintena & reg_iodira);	// 選ばれた全ての有効な割り込みﾋﾞｯﾄを決定

  if(int_bits & 0x01)
  {
	if((PIND & 0x01) || ((reg_intcona & 0x01) & (reg_defvala & 0x01)))		// 入力が既に'1'またはDEFVAL='1'なら、EXT0に対して下降端起動
	{
	  EICRA|=(1<<ISC01);				// EICRAのISC0nﾋﾞｯﾄを'10'に設定
	  EICRA&=~(1<<ISC00);
	}
	else								// さもなければ、上昇端起動
	{
	  EICRA|=(1<<ISC01 | 1<<ISC00);		// EICRAのISC0nﾋﾞｯﾄを'11'に設定
	}
  }
 
  if(int_bits & 0x02)
  {
	if((PIND & 0x02)  || ((reg_intcona & 0x02) & (reg_defvala & 0x02)))		// 入力が既に'1'またはDEFVAL='1'なら、EXT1に対して下降端起動
	{
	  EICRA|=(1<<ISC11);				// EICRAのISC1nﾋﾞｯﾄを'10'に設定
	  EICRA&=~(1<<ISC10);
	}
	else								// さもなければ、上昇端起動
	{
	  EICRA|=(1<<ISC11 | 1<<ISC10);		// EICRAのISC1nﾋﾞｯﾄを'11'に設定
	}
  }

  if(int_bits & 0x04)
  {
	if((PIND & 0x04)  || ((reg_intcona & 0x04) & (reg_defvala & 0x04)))		// 入力が既に'1'またはDEFVAL='1'なら、EXT2に対して下降端起動
	{
	  EICRA|=(1<<ISC21);				// EICRAのISC2nﾋﾞｯﾄを'10'に設定
	  EICRA&=~(1<<ISC20);
	}
	else								// さもなければ、上昇端起動
	{
	  EICRA|=(1<<ISC21 | 1<<ISC20);		// EICRAのISC2nﾋﾞｯﾄを'11'に設定
	}
  }

  if(int_bits & 0x08)
  {
	if((PIND & 0x08) || ((reg_intcona & 0x08) & (reg_defvala & 0x08)))		// 入力が既に'1'またはDEFVAL='1'なら、EXT3に対して下降端起動
	{
	  EICRA|=(1<<ISC31);				// EICRAのISC3nﾋﾞｯﾄを'10'に設定
	  EICRA&=~(1<<ISC30);
	}
	else								// さもなければ、上昇端起動
	{
	  EICRA|=(1<<ISC31 | 1<<ISC30);		// EICRAのISC3nﾋﾞｯﾄを'11'に設定
	}
  }

  if(int_bits & 0x10)
  {
	if((PINE & 0x10)  || ((reg_intcona & 0x10) & (reg_defvala & 0x10)))		// 入力が既に'1'またはDEFVAL='1'なら、EXT4に対して下降端起動
	{
	  EICRB|=(1<<ISC41);				// EICRAのISC4nﾋﾞｯﾄを'10'に設定
	  EICRB&=~(1<<ISC40);
	}
	else								// さもなければ、上昇端起動
	{
	  EICRB|=(1<<ISC41 | 1<<ISC40);		// EICRAのISC4nﾋﾞｯﾄを'11'に設定
	}
  }

  if(int_bits & 0x20)
  {
	if((PINE & 0x20)  || ((reg_intcona & 0x20) & (reg_defvala & 0x20)))		// 入力が既に'1'またはDEFVAL='1'なら、EXT5に対して下降端起動
	{
	  EICRB|=(1<<ISC51);				// EICRAのISC5nﾋﾞｯﾄを'10'に設定
	  EICRB&=~(1<<ISC50);
	}
	else								// さもなければ、上昇端起動
	{
	  EICRB|=(1<<ISC51 | 1<<ISC50);		// EICRAのISC5nﾋﾞｯﾄを'11'に設定
	}
  }

  if(int_bits & 0x40)
  {
	if((PINE & 0x40)  || ((reg_intcona & 0x40) & (reg_defvala & 0x40)))		// 入力が既に'1'またはDEFVAL='1'なら、EXT6に対して下降端起動
	{
	  EICRB|=(1<<ISC61);				// EICRAのISC6nﾋﾞｯﾄを'10'に設定
	  EICRB&=~(1<<ISC60);
	}
	else								// さもなければ、上昇端起動
	{
	  EICRB|=(1<<ISC61 | 1<<ISC60);		// EICRAのISC6nﾋﾞｯﾄを'11'に設定
	}
  }

  if(int_bits & 0x80)
  {
	if((PINE & 0x80)  || ((reg_intcona & 0x80) & (reg_defvala & 0x80)))		// 入力が既に'1'またはDEFVAL='1'なら、EXT7に対して下降端起動
	{
	  EICRB|=(1<<ISC71);				// EICRAのISC7nﾋﾞｯﾄを'10'に設定
	  EICRB&=~(1<<ISC70);
	}
	else								// さもなければ、上昇端起動
	{
	  EICRB|=(1<<ISC71 | 1<<ISC70);		// EICRAのISC7nﾋﾞｯﾄを'11'に設定
	}
  }
  EIMSK=int_bits;						// 選ばれた外部割り込みを有効設定

  // EICRAとEICRBの弄り回しが偽外部割り込みを引き起こし得るため、それらに'1'を書くことによって全ﾌﾗｸﾞを解除
  EIFR=0xFF;							// 全ﾌﾗｸﾞ解除
  SREG=sreg;							// 全体割り込み状況復元
} //configure_interrupts()の終わり

void init_ports(void)
{
  // "ATmegaS128ﾎﾟｰﾄ拡張器信号模倣表"文書に合うようにATmegaS128の入出力ﾋﾟﾝを設定
  DDRA&=0xF8;							// A2～0は既定で入力、どの使用例でも論理的に一致されるべきです。
  INTA_PORT|=(1<<INTA);					// INTAﾋﾟﾝをMCP23S17のﾃﾞｰﾀｼｰﾄのように'1'に設定
  INTA_DDR|=(1<<INTA);					// INTAﾋﾟﾝをMCP23S17のﾃﾞｰﾀｼｰﾄのように出力として設定
  DDRD&=0xF0;							// GPIOA3～0は既定で入力、この割り当てが割り込み能力を失うことなく変更できないことに注意
  DDRE&=0x0F;							// GPIOA7～4は既定で入力、この割り当てが割り込み能力を失うことなく変更できないことに注意
  DDRC=0;								// GPIOBは全部入力(また既定値)
} // init_ports()の終わり

void init_spi(void)
{
  SPI_PORT |= (1<<DD_SS);														// 不具合を避けるためにSS*線のﾌﾟﾙｱｯﾌﾟ有効
  SPI_DDR &= ~((1<<DD_MOSI)|(1<<DD_SS)|(1<<DD_SCK));							// SPI従装置用入力ﾋﾟﾝ
  SPI_DDR |= (1<<DD_MISO);														// SPI従装置用出力ﾋﾟﾝ
  SPCR=((0<<SPIE)|(1<<SPE)|(0<<DORD)|(0<<MSTR)|(0<<CPOL)|(0<<CPHA)|(0<<SPR0));	// SPI通信規約用構成設定
} // init_spi()の終わり

unsigned char get_spi_byte(void)
{
  while(!(SPSR&(1<<SPIF)));				// ﾊﾞｲﾄ受信待ち
  return SPDR;							// ﾊｰﾄﾞｳｪｱから受信ﾊﾞｲﾄ取得
} // get_spi_byte()の終わり
